Index: proj/bmp/pistol.bmp
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = image/x-ms-bmp
Index: proj/bmp/pistol.bmp
===================================================================
--- proj/bmp/pistol.bmp	(revision 215)
+++ proj/bmp/pistol.bmp	(nonexistent)

Property changes on: proj/bmp/pistol.bmp
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Deleted: svn:mime-type
## -1 +0,0 ##
-image/x-ms-bmp
\ No newline at end of property
Index: proj/bmp/shooter.bmp
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = image/x-ms-bmp
Index: proj/bmp/shooter.bmp
===================================================================
--- proj/bmp/shooter.bmp	(revision 215)
+++ proj/bmp/shooter.bmp	(nonexistent)

Property changes on: proj/bmp/shooter.bmp
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Deleted: svn:mime-type
## -1 +0,0 ##
-image/x-ms-bmp
\ No newline at end of property
Index: proj/xpm/map.xpm
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = image/x-xpmi
Index: proj/xpm/map.xpm
===================================================================
--- proj/xpm/map.xpm	(revision 215)
+++ proj/xpm/map.xpm	(nonexistent)

Property changes on: proj/xpm/map.xpm
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Deleted: svn:mime-type
## -1 +0,0 ##
-image/x-xpmi
\ No newline at end of property
Index: proj/xpm/map.h
===================================================================
--- proj/xpm/map.h	(revision 215)
+++ proj/xpm/map.h	(nonexistent)
@@ -1,11 +0,0 @@
-#ifndef MAP_H_INCLUDED
-#define MAP_H_INCLUDED
-
-#include "map.xpm"
-#include "sprite.h"
-
-basic_sprite_t* get_map(void){
-    return basic_sprite_ctor((const char **)map_xpm, 0, 0);
-}
-
-#endif /* end of include guard: MAP_H_INCLUDED */

Property changes on: proj/xpm/map.h
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Index: proj/include/ent.h
===================================================================
--- proj/include/ent.h	(revision 215)
+++ proj/include/ent.h	(revision 216)
@@ -14,8 +14,8 @@
 typedef struct gunner gunner_t;
 gunner_t* (gunner_ctor)(basic_sprite_t *dude, basic_sprite_t *weapon);
 void      (gunner_dtor)(gunner_t *p);
-void (gunner_set_pos)  (gunner_t *p, int16_t x, int16_t y);
-void (gunner_set_angle)(gunner_t *p, double angle        );
+void (gunner_set_pos)  (gunner_t *p, double x, double y);
+void (gunner_set_angle)(gunner_t *p, double angle      );
 double  (gunner_get_x)       (const gunner_t *p);
 double  (gunner_get_y)       (const gunner_t *p);
 int16_t (gunner_get_x_screen)(const gunner_t *p);
@@ -26,7 +26,7 @@
 typedef struct bullet bullet_t;
 bullet_t* (bullet_ctor)(basic_sprite_t *b);
 void      (bullet_dtor)(bullet_t *p);
-void (bullet_set_pos)  (bullet_t *p, int16_t x, int16_t y);
+void (bullet_set_pos)  (bullet_t *p, double x, double y);
 void (bullet_set_angle)(bullet_t *p, double angle        );
 double  (bullet_get_x)       (const bullet_t *p);
 double  (bullet_get_y)       (const bullet_t *p);
@@ -34,4 +34,11 @@
 int16_t (bullet_get_y_screen)(const bullet_t *p);
 void (bullet_draw)(bullet_t *p);
 
+struct map;
+typedef struct map map_t;
+map_t* (map_ctor)(const char **background, const char **collide);
+void   (map_dtor)(map_t *p);
+int    (map_collides)(const map_t *p, double x, double y);
+void   (map_draw)(map_t *p);
+
 #endif //ENT_H_INCLUDED
Index: proj/include/graph_macros.h
===================================================================
--- proj/include/graph_macros.h	(revision 215)
+++ proj/include/graph_macros.h	(revision 216)
@@ -31,4 +31,7 @@
 #define BLACK               0x000000
 #define WHITE               0xFFFFFF
 
+// Alpha
+#define ALPHA_THRESHOLD     0x7F
+
 #endif /* end of include guard: GRAPHICS_MACROS_H_INCLUDED */
Index: proj/include/proj_macros.h
===================================================================
--- proj/include/proj_macros.h	(revision 215)
+++ proj/include/proj_macros.h	(revision 216)
@@ -15,7 +15,7 @@
 #define CTRL_MAKE_CODE      0x1D    /** @brief CTRL Make Code */
 #define CTRL_BREAK_CODE     0x9D    /** @brief CTRL Break Code */
 #define PLUS_MAKE_CODE      0x1A    /** @brief Plus (+) Make Code */
-#define PLUS_BREAK_CODE      0x9A   /** @brief Plus (+) Break Code */
+#define PLUS_BREAK_CODE     0x9A    /** @brief Plus (+) Break Code */
 #define MINUS_MAKE_CODE     0x35    /** @brief Minus (-) Make Code */
 #define MINUS_BREAK_CODE    0xB5    /** @brief Minus (-) Break Code */
 
Index: proj/include/sprite.h
===================================================================
--- proj/include/sprite.h	(revision 215)
+++ proj/include/sprite.h	(revision 216)
@@ -6,13 +6,23 @@
 
 basic_sprite_t* (basic_sprite_ctor)(const char **xpm, int16_t u0, int16_t v0);
 void            (basic_sprite_dtor)(basic_sprite_t *p);
-
 const uint8_t* (basic_sprite_get_map)(const basic_sprite_t *p);
 uint16_t       (basic_sprite_get_w)  (const basic_sprite_t *p);
 uint16_t       (basic_sprite_get_h)  (const basic_sprite_t *p);
 int16_t        (basic_sprite_get_u0) (const basic_sprite_t *p);
 int16_t        (basic_sprite_get_v0) (const basic_sprite_t *p);
+/*
+struct basic_sprite_alpha;
+typedef struct basic_sprite_alpha basic_sprite_alpha_t;
 
+basic_sprite_alpha_t* (basic_sprite_alpha_ctor)(const char **xpm, int16_t u0, int16_t v0);
+void                  (basic_sprite_alpha_dtor)(basic_sprite_alpha_t *p);
+const uint8_t*        (basic_sprite_alpha_get_map)(const basic_sprite_alpha_t *p);
+uint16_t              (basic_sprite_alpha_get_w)  (const basic_sprite_alpha_t *p);
+uint16_t              (basic_sprite_alpha_get_h)  (const basic_sprite_alpha_t *p);
+int16_t               (basic_sprite_alpha_get_u0) (const basic_sprite_alpha_t *p);
+int16_t               (basic_sprite_alpha_get_v0) (const basic_sprite_alpha_t *p);
+*/
 struct sprite;
 typedef struct sprite sprite_t;
 
Index: proj/maps/map1.h
===================================================================
--- proj/maps/map1.h	(nonexistent)
+++ proj/maps/map1.h	(revision 216)
@@ -0,0 +1,12 @@
+#ifndef MAP1_H_INCLUDED
+#define MAP1_H_INCLUDED
+
+#include "map1.xpm"
+#include "map1_collide.xpm"
+#include "sprite.h"
+
+map_t* get_map1(void){
+    return map_ctor((const char **)map1_xpm, (const char **)map1_collide_xpm);
+}
+
+#endif /* end of include guard: MAP_H_INCLUDED */

Property changes on: proj/maps/map1.h
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/maps/map1.xpm
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = image/x-xpmi
Index: proj/maps/map1.xpm
===================================================================
--- proj/maps/map1.xpm	(nonexistent)
+++ proj/maps/map1.xpm	(revision 216)

Property changes on: proj/maps/map1.xpm
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:mime-type
## -0,0 +1 ##
+image/x-xpmi
\ No newline at end of property
Index: proj/maps/map1_collide.xpm
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = image/x-xpmi
Index: proj/maps/map1_collide.xpm
===================================================================
--- proj/maps/map1_collide.xpm	(nonexistent)
+++ proj/maps/map1_collide.xpm	(revision 216)

Property changes on: proj/maps/map1_collide.xpm
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Added: svn:mime-type
## -0,0 +1 ##
+image/x-xpmi
\ No newline at end of property
Index: proj/src/ent.c
===================================================================
--- proj/src/ent.c	(revision 215)
+++ proj/src/ent.c	(revision 216)
@@ -3,6 +3,7 @@
 #include "ent.h"
 
 #include "graph.h"
+#include "sprite.h"
 
 static double scale = 1.0;
 static int16_t x_origin = 0;
@@ -37,8 +38,8 @@
     sprite_dtor(p->weapon);
     free(p);
 }
-void (gunner_set_pos)  (gunner_t *p, int16_t x, int16_t y){ p->x = x; p->y = y; }
-void (gunner_set_angle)(gunner_t *p, double angle        ){
+void (gunner_set_pos)  (gunner_t *p, double x, double y){ p->x = x; p->y = y; }
+void (gunner_set_angle)(gunner_t *p, double angle      ){
     sprite_set_angle(p->dude  , angle);
     sprite_set_angle(p->weapon, angle);
 }
@@ -77,8 +78,8 @@
     sprite_dtor(p->b);
     free(p);
 }
-void (bullet_set_pos)  (bullet_t *p, int16_t x, int16_t y){ p->x = x; p->y = y; }
-void (bullet_set_angle)(bullet_t *p, double angle        ){ sprite_set_angle(p->b, angle); }
+void (bullet_set_pos)  (bullet_t *p, double x, double y){ p->x = x; p->y = y; }
+void (bullet_set_angle)(bullet_t *p, double angle      ){ sprite_set_angle(p->b, angle); }
 double  (bullet_get_x)       (const bullet_t *p){ return p->x; }
 double  (bullet_get_y)       (const bullet_t *p){ return p->y; }
 int16_t (bullet_get_x_screen)(const bullet_t *p){ return (p->x-x_origin)*scale; }
@@ -90,3 +91,59 @@
     sprite_set_scale(p->b, scale);
     sprite_draw     (p->b);
 }
+
+struct map{
+    basic_sprite_t *bsp_background;
+    sprite_t *background;
+    uint8_t *collide;
+};
+map_t* (map_ctor)(const char **background, const char **collide){
+    map_t *ret = malloc(sizeof(map_t));
+    if(ret == NULL) return NULL;
+
+    ret->bsp_background = NULL;
+    ret->background     = NULL;
+    ret->collide        = NULL;
+
+    ret->bsp_background = basic_sprite_ctor(background, 0, 0);
+    ret->background     = sprite_ctor(ret->bsp_background);
+    if(ret->bsp_background == NULL ||
+        ret->background     == NULL){ map_dtor(ret); return NULL; }
+
+    basic_sprite_t *bsp_collide = basic_sprite_ctor(collide, 0, 0);
+    if(bsp_collide == NULL){ map_dtor(ret); return NULL; }
+    const uint16_t W = basic_sprite_get_w(bsp_collide);
+    const uint16_t H = basic_sprite_get_h(bsp_collide);
+    ret->collide = malloc(W*H*sizeof(uint8_t));
+    if(ret->collide == NULL){ map_dtor(ret); return NULL; }
+    const uint8_t *m = basic_sprite_get_map(bsp_collide);
+    for(unsigned i = 0; i < W*H; ++i){
+        ret->collide[i] = (m[4*i+3] < ALPHA_THRESHOLD ? 1 : 0);
+    }
+    basic_sprite_dtor(bsp_collide);
+
+    return ret;
+}
+void (map_dtor)(map_t *p){
+    if(p == NULL) return;
+    sprite_dtor(p->background);
+    basic_sprite_dtor(p->bsp_background);
+    free(p->collide);
+    free(p);
+}
+int16_t (map_get_x_screen)(const map_t *p){ return (-x_origin)*scale; }
+int16_t (map_get_y_screen)(const map_t *p){ return (-y_origin)*scale; }
+int (map_collides)(const map_t *p, double x, double y){
+    const uint16_t w = sprite_get_w(p->background), h = sprite_get_h(p->background);
+    int16_t x_ = x, y_ = y;
+    if(x_ < 0 || w <= x_ || y_ < 0 || h <= y_) return 0;
+    uint32_t pos = x_ + y_*w;
+    return p->collide[pos];
+}
+void   (map_draw)(map_t *p){
+    const int16_t x_screen = map_get_x_screen(p);
+    const int16_t y_screen = map_get_y_screen(p);
+    sprite_set_pos  (p->background, x_screen, y_screen);
+    sprite_set_scale(p->background, scale);
+    sprite_draw     (p->background);
+}
Index: proj/src/graph.c
===================================================================
--- proj/src/graph.c	(revision 215)
+++ proj/src/graph.c	(revision 216)
@@ -271,7 +271,6 @@
     uint16_t w, h;
     int16_t u0, v0;
 };
-
 basic_sprite_t* (basic_sprite_ctor)(const char **xpm, int16_t u0, int16_t v0){
     basic_sprite_t *ret = malloc(sizeof(basic_sprite_t));
     if(ret == NULL) return NULL;
@@ -279,7 +278,7 @@
     xpm_image_t img;
     ret->map = xpm_load((xpm_map_t)xpm, type, &img);
     if(ret->map == NULL){
-        free(ret);
+        basic_sprite_dtor(ret);
         return NULL;
     }
     ret->w = img.width;
@@ -293,7 +292,6 @@
     free(p->map);
     free(p);
 }
-
 const uint8_t* (basic_sprite_get_map)(const basic_sprite_t *p){ return p->map; }
 uint16_t       (basic_sprite_get_w)  (const basic_sprite_t *p){ return p->w  ; }
 uint16_t       (basic_sprite_get_h)  (const basic_sprite_t *p){ return p->h  ; }
@@ -300,6 +298,46 @@
 int16_t        (basic_sprite_get_u0) (const basic_sprite_t *p){ return p->u0 ; }
 int16_t        (basic_sprite_get_v0) (const basic_sprite_t *p){ return p->v0 ; }
 
+/*
+struct basic_sprite_alpha{
+    uint8_t *map;
+    uint16_t w, h;
+    int16_t u0, v0;
+};
+basic_sprite_alpha_t* (basic_sprite_alpha_ctor)(const char **xpm, int16_t u0, int16_t v0){
+    basic_sprite_alpha_t *ret = malloc(sizeof(basic_sprite_t));
+    if(ret == NULL) return NULL;
+    enum xpm_image_type type = XPM_8_8_8_8;
+    xpm_image_t img;
+    ret->map = NULL;
+    uint8_t *m = xpm_load((xpm_map_t)xpm, type, &img);
+    if(m == NULL){
+        basic_sprite_alpha_dtor(ret);
+        return NULL;
+    }
+    ret->map = m;
+    if(ret->map == NULL){
+        basic_sprite_alpha_dtor(ret);
+        return NULL;
+    }
+    ret->w = img.width;
+    ret->h = img.height;
+    ret->u0 = u0;
+    ret->v0 = v0;
+    return ret;
+}
+void (basic_sprite_alpha_dtor)(basic_sprite_alpha_t *p){
+    if(p == NULL) return;
+    free(p->map);
+    free(p);
+}
+const uint8_t* (basic_sprite_alpha_get_map)(const basic_sprite_alpha_t *p){ return p->map; }
+uint16_t       (basic_sprite_alpha_get_w)  (const basic_sprite_alpha_t *p){ return p->w  ; }
+uint16_t       (basic_sprite_alpha_get_h)  (const basic_sprite_alpha_t *p){ return p->h  ; }
+int16_t        (basic_sprite_alpha_get_u0) (const basic_sprite_alpha_t *p){ return p->u0 ; }
+int16_t        (basic_sprite_alpha_get_v0) (const basic_sprite_alpha_t *p){ return p->v0 ; }
+*/
+
 struct sprite{
     const basic_sprite_t *bsp;
     int16_t x, y; //position in screen
@@ -306,7 +344,6 @@
     double theta, s, c;
     double scale;
 };
-
 sprite_t* (sprite_ctor)(const basic_sprite_t *bsp){
     sprite_t *ret = malloc(sizeof(sprite_t));
     if(ret == NULL) return NULL;
@@ -321,13 +358,13 @@
     if(p == NULL) return;
     free(p);
 }
-
 void (sprite_set_pos)   (sprite_t *p, int16_t x , int16_t y ){ p->x = x; p->y = y; }
 void (sprite_set_angle) (sprite_t *p, double angle          ){ p->theta = angle; p->c = fm_cos(p->theta); p->s = fm_sin(p->theta); }
 void (sprite_set_scale) (sprite_t *p, double scale          ){ p->scale = scale; }
 int16_t  (sprite_get_x)(const sprite_t *p){ return p->x; }
 int16_t  (sprite_get_y)(const sprite_t *p){ return p->y; }
-
+uint16_t (sprite_get_w)(const sprite_t *p){ return basic_sprite_get_w(p->bsp); }
+uint16_t (sprite_get_h)(const sprite_t *p){ return basic_sprite_get_h(p->bsp); }
 void (sprite_src2pic)(const sprite_t *p, int16_t x, int16_t y, int16_t *u, int16_t *v){
     double dx = (x - p->x)/p->scale;
     double dy = (y - p->y)/p->scale;
@@ -336,7 +373,6 @@
     *u = du + basic_sprite_get_u0(p->bsp);
     *v = dv + basic_sprite_get_v0(p->bsp);
 }
-
 void (sprite_pic2src)(const sprite_t *p, int16_t u, int16_t v, int16_t *x, int16_t *y){
     int16_t du = u - basic_sprite_get_u0(p->bsp);
     int16_t dv = v - basic_sprite_get_v0(p->bsp);
@@ -345,7 +381,6 @@
     *x = dx*p->scale + 0.5 + p->x;
     *y = dy*p->scale + 0.5 + p->y;
 }
-
 void (sprite_draw)(const sprite_t *p){
     const uint16_t w = basic_sprite_get_w(p->bsp);
     const uint16_t h = basic_sprite_get_h(p->bsp);
@@ -370,7 +405,7 @@
             sprite_src2pic(p, x, y, &u, &v);
             if(0 <= u && u < w && 0 <= v && v < h){
                 const uint8_t *c_p = map+(v*w+u)*4;
-                if(*(c_p+3) < 0x7F) //alpha
+                if(*(c_p+3) < ALPHA_THRESHOLD) //alpha
                     memcpy(place, c_p, bytes_pixel);
             }
         }
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 215)
+++ proj/src/proj.c	(revision 216)
@@ -24,7 +24,7 @@
 #include "pistol.h"
 #include "nothing.h"
 #include "bullet.h"
-#include "map.h"
+#include "map1.h"
 
 int main(int argc, char* argv[]) {
 
@@ -59,11 +59,12 @@
     }
 
     /// Load stuff
-    basic_sprite_t *bsp_crosshair = NULL;
-    basic_sprite_t *bsp_shooter   = NULL;
-    basic_sprite_t *bsp_pistol    = NULL;
-    basic_sprite_t *bsp_nothing   = NULL;
-    sprite_t       *sp_crosshair  = NULL;
+    basic_sprite_t       *bsp_crosshair = NULL;
+    basic_sprite_t       *bsp_shooter   = NULL;
+    basic_sprite_t       *bsp_pistol    = NULL;
+    basic_sprite_t       *bsp_nothing   = NULL;
+    map_t                *map1      = NULL;
+    sprite_t             *sp_crosshair  = NULL;
     {
         graph_clear_screen();
         text_t *txt = text_ctor(consolas, "Loading...");
@@ -75,6 +76,7 @@
         bsp_shooter   = get_shooter  (); if(bsp_shooter   == NULL) printf("Failed to get shooter\n");
         bsp_pistol    = get_pistol   (); if(bsp_pistol    == NULL) printf("Failed to get pistol\n");
         bsp_nothing   = get_nothing  (); if(bsp_nothing   == NULL) printf("Failed to get nothing\n");
+        map1          = get_map1     (); if(map1          == NULL) printf("Failed to get map1\n");
 
         sp_crosshair = sprite_ctor(bsp_crosshair); if(sp_crosshair == NULL) printf("Failed to get crosshair sprite\n");
     }
@@ -109,7 +111,7 @@
     #endif
 
     #ifdef TELMO
-        ent_set_scale(10.0);
+        ent_set_scale(DEFAULT_SCALE);
 
         gunner_t *shooter1 = gunner_ctor(bsp_shooter, bsp_pistol); if(shooter1 == NULL) printf("Failed to get shooter1\n");
         gunner_set_pos(shooter1, 0, 0);
@@ -120,19 +122,10 @@
         bullet_t *bullet = bullet_ctor(get_bullet());
         bullet_set_pos(bullet, 400, 400);
 
-        ent_set_origin(bullet_get_x(bullet)-ent_get_XLength()/2.0,
-                       bullet_get_y(bullet)-ent_get_YLength()/2.0);
+        ent_set_origin(gunner_get_x(shooter1)-ent_get_XLength()/2.0,
+                       gunner_get_y(shooter1)-ent_get_YLength()/2.0);
 
-        graph_clear_screen();
-        gunner_draw(shooter1);
-        sprite_draw(sp_crosshair);
-        graph_draw();
-
         uint32_t refresh_count_value = sys_hz() / REFRESH_RATE;
-
-        basic_sprite_t *bsp_pink = get_map();
-        sprite_t *pink = sprite_ctor(bsp_pink);
-        basic_sprite_dtor(bsp_pink);
     #endif
 
     /// loop stuff
@@ -161,10 +154,15 @@
                             if (i == 0) {
                                 if (no_interrupts % refresh_count_value == 0) {
                                     update_movement(shooter1);
+
+                                    if(map_collides(map1, gunner_get_x(shooter1), gunner_get_y(shooter1))){
+                                        printf("COLLIDING\n");
+                                    }
+
                                     update_scale();
 
-                                    ent_set_origin(bullet_get_x(bullet)-ent_get_XLength()/2.0,
-                                                   bullet_get_y(bullet)-ent_get_YLength()/2.0);
+                                    ent_set_origin(gunner_get_x(shooter1)-ent_get_XLength()/2.0,
+                                                   gunner_get_y(shooter1)-ent_get_YLength()/2.0);
 
                                     sprite_set_pos(sp_crosshair, get_mouse_X(), get_mouse_Y());
                                     double angle = get_mouse_angle(shooter1);
@@ -173,7 +171,7 @@
 
                                     clock_t t = clock();
 
-                                    sprite_draw(pink);
+                                    map_draw   (map1);
                                     gunner_draw(shooter2);
                                     gunner_draw(shooter1);
                                     bullet_draw(bullet);
@@ -207,13 +205,17 @@
 
     #ifdef TELMO
         gunner_dtor(shooter1); shooter1 = NULL;
-        sprite_dtor(pink); pink = NULL;
+        gunner_dtor(shooter2); shooter2 = NULL;
+        bullet_dtor(bullet); bullet = NULL;
     #endif
 
-    basic_sprite_dtor(bsp_crosshair); bsp_crosshair = NULL;
-    basic_sprite_dtor(bsp_shooter  ); bsp_shooter   = NULL;
-    sprite_dtor      (sp_crosshair ); sp_crosshair  = NULL;
-    font_dtor        (consolas     ); consolas      = NULL;
+    basic_sprite_dtor      (bsp_crosshair); bsp_crosshair = NULL;
+    basic_sprite_dtor      (bsp_shooter  ); bsp_shooter   = NULL;
+    sprite_dtor            (sp_crosshair ); sp_crosshair  = NULL;
+    basic_sprite_dtor      (bsp_pistol   ); bsp_pistol    = NULL;
+    basic_sprite_dtor      (bsp_nothing  ); bsp_nothing   = NULL;
+    map_dtor               (map1         ); map1          = NULL;
+    font_dtor              (consolas     ); consolas      = NULL;
 
     // Unsubscribe interrupts
     if (unsubscribe_all()) {
Index: proj/DR.mk
===================================================================
--- proj/DR.mk	(revision 215)
+++ proj/DR.mk	(revision 216)
@@ -4,7 +4,7 @@
 
 SRCS= proj.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
-CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D DIOGO -D __LCOM_OPTIMIZED_
+CPPFLAGS += -pedantic -I./include -I./maps -I./xpm -D LCOM_MACRO -D DIOGO -D __LCOM_OPTIMIZED_
 
 DPADD += ${LIBLCF}
 LDADD += -llcf
Index: proj/Makefile
===================================================================
--- proj/Makefile	(revision 215)
+++ proj/Makefile	(revision 216)
@@ -4,7 +4,7 @@
 
 SRCS= proj.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
-CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D __LCOM_OPTIMIZED_
+CPPFLAGS += -pedantic -I./include -I./maps -I./xpm -D LCOM_MACRO -D __LCOM_OPTIMIZED_
 
 DPADD += ${LIBLCF}
 LDADD += -llcf
Index: proj/TB.mk
===================================================================
--- proj/TB.mk	(revision 215)
+++ proj/TB.mk	(revision 216)
@@ -4,7 +4,7 @@
 
 SRCS= proj.c graph.c kbc.c keyboard.c mouse.c utils.c timer.c interrupts_func.c proj_func.c fast_math.c rectangle.c font.c xpm_utils.c ent.c
 
-CPPFLAGS += -pedantic -I./include -I./bmp -I./xpm -D LCOM_MACRO -D TELMO #-D __LCOM_OPTIMIZED_
+CPPFLAGS += -pedantic -I./include -I./maps -I./xpm -D LCOM_MACRO -D TELMO #-D __LCOM_OPTIMIZED_
 
 DPADD += ${LIBLCF}
 LDADD += -llcf