Index: proj/font/process_Consolas.sh
===================================================================
--- proj/font/process_Consolas.sh	(revision 218)
+++ proj/font/process_Consolas.sh	(nonexistent)
@@ -1 +0,0 @@
-./process_font.sh Consolas 59 147 16 6 32

Property changes on: proj/font/process_Consolas.sh
___________________________________________________________________
Deleted: svn:executable
## -1 +0,0 ##
-*
\ No newline at end of property
Index: proj/helpers/xpm_to_xpm2.sh
===================================================================
--- proj/helpers/xpm_to_xpm2.sh	(revision 218)
+++ proj/helpers/xpm_to_xpm2.sh	(revision 219)
@@ -1,16 +1,17 @@
 cd $1
 echo "#include \"xpm_utils.h\"" > convert.c
 for f in xpm/*.xpm; do
-    echo "#include \"$f\"" >> convert.c 
+    echo "#include \"$f\"" >> convert.c
 done
 echo "int main(){" >> convert.c
 for f in xpm/*.xpm; do
+    xpmname="$(cat $f | grep -oP 'char *\* *[a-zA-Z0-9_]*' | sed 's/char *\* *\([a-zA-Z0-9_]*\)/\1/')"
     s=${f:4:-4}
-    echo "    xpm_save_as_xpm2($s,\"xpm2/$s.xpm2\");" >> convert.c
+    echo "    xpm_save_as_xpm2((const char **)$xpmname,\"xpm2/$s.xpm2\");" >> convert.c
 done
 echo "    return 0;" >> convert.c
 echo "}" >> convert.c
-gcc -I../../include ../../src/xpm_utils.c convert.c -o convert.app
+gcc -I/media/DATA/VirtualBox_VMs/MINIX-LCOM/shared/proj/include /media/DATA/VirtualBox_VMs/MINIX-LCOM/shared/proj/src/xpm_utils.c convert.c -o convert.app
 rm -rf xpm2
 mkdir xpm2
 ./convert.app
Index: proj/include/xpm_utils.h
===================================================================
--- proj/include/xpm_utils.h	(revision 218)
+++ proj/include/xpm_utils.h	(revision 219)
@@ -1,7 +1,7 @@
 #ifndef XMP_UTILS_H_INCLUDED
 #define XMP_UTILS_H_INCLUDED
 
-void xpm_save_as_xpm2(char **p, const char *s);
+void xpm_save_as_xpm2(const char **p, const char *s);
 
 char** xpm_load_xpm2(const char *s);
 
Index: proj/src/xpm_utils.c
===================================================================
--- proj/src/xpm_utils.c	(revision 218)
+++ proj/src/xpm_utils.c	(revision 219)
@@ -8,7 +8,7 @@
 #include <stdlib.h>
 #include <string.h>
 
-void xpm_save_as_xpm2(char **p, const char *s){
+void xpm_save_as_xpm2(const char **p, const char *s){
     FILE *f = fopen(s, "w");
     int w, h, num_colors, chars_per_pixel;
     sscanf(p[0], "%d %d %d %d", &w, &h, &num_colors, &chars_per_pixel);
Index: proj/xpm2/bullet.xpm2
===================================================================
--- proj/xpm2/bullet.xpm2	(nonexistent)
+++ proj/xpm2/bullet.xpm2	(revision 219)
@@ -0,0 +1,23 @@
+7 15 7 1
+ 	c None
+.	c #00DDFF
++	c #E59451
+@	c #D37629
+#	c #D8A274
+$	c #F46F00
+%	c #DDBA9D
+   .   
+  .+.  
+ .@+#. 
+..@+#..
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.$@+#%.
+.......

Property changes on: proj/xpm2/bullet.xpm2
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/xpm2/crosshair.xpm2
===================================================================
--- proj/xpm2/crosshair.xpm2	(nonexistent)
+++ proj/xpm2/crosshair.xpm2	(revision 219)
@@ -0,0 +1,35 @@
+32 32 2 1
+ 	c None
+.	c #00FF4D
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                                
+                                
+                                
+.............   .   ............
+                                
+                                
+                                
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               
+                .               

Property changes on: proj/xpm2/crosshair.xpm2
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/xpm2/nothing.xpm2
===================================================================
--- proj/xpm2/nothing.xpm2	(nonexistent)
+++ proj/xpm2/nothing.xpm2	(revision 219)
@@ -0,0 +1,72 @@
+70 70 1 1
+ 	c None
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      

Property changes on: proj/xpm2/nothing.xpm2
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/xpm2/pistol.xpm2
===================================================================
--- proj/xpm2/pistol.xpm2	(nonexistent)
+++ proj/xpm2/pistol.xpm2	(revision 219)
@@ -0,0 +1,73 @@
+70 70 2 1
+ 	c None
+.	c #303030
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                        .             
+                                                       ...            
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                       ....           
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      

Property changes on: proj/xpm2/pistol.xpm2
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/xpm2/shooter.xpm2
===================================================================
--- proj/xpm2/shooter.xpm2	(nonexistent)
+++ proj/xpm2/shooter.xpm2	(revision 219)
@@ -0,0 +1,95 @@
+70 70 24 1
+ 	c None
+.	c #FFE97F
++	c #267F00
+@	c #277F00
+#	c #FFEB81
+$	c #FFEF83
+%	c #FDE97E
+&	c #000000
+*	c #268000
+=	c #287F00
+-	c #267F06
+;	c #227F00
+>	c #278200
+,	c #FF0000
+'	c #008100
+)	c #277E00
+!	c #0094FF
+~	c #0095FF
+{	c #278100
+]	c #028000
+^	c #267F07
+/	c #267F01
+(	c #278300
+_	c #267E00
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                              .........                               
+                             ...........                              
+                           ...............                            
+                 +++@++..#.................$.++++++++                 
+              ++++++++......................%..+++++++++              
+              +++++++...........................++++++++              
+             ++++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&+*+++++++             
+           ++++++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++++++           
+           =++++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+*+++++++-           
+           ;+++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+>++++++++           
+,,,,,,,,,,+'+++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++*+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&++++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'++++{+&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++)+!~!!!!!!!!
+,,,,,,,,,,+'+++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&++++++++)+!~!!!!!!!!
+,,,,,,,,,,+]+++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++++++!~!!!!!!!!
+           =+++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++++^           
+           +++++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&&++++++++++/           
+            +++++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&++++++++++            
+             ++++++++&&&&&&&&&&&&&&&&&&&&&&&&&&&+++++++++             
+              ++++++*+&&&&&&&&&&&&&&&&&&&&&&&&+(++++++++              
+                 ++++++&&&&&&&&&&&&&&&&&&&&&&+_{+++++                 
+                 +++++++&&&&&&&&&&&&&&&&&&&&&+(++++++                 
+                        &&&&&&&&&&&&&&&&&&&&&                         
+                         &&&&&&&&&&&&&&&&&&&&                         
+                             &&&&&&&&&&&&                             
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      
+                                                                      

Property changes on: proj/xpm2/shooter.xpm2
___________________________________________________________________
Added: svn:executable
## -0,0 +1 ##
+*
\ No newline at end of property
Index: proj/setup.sh
===================================================================
--- proj/setup.sh	(revision 218)
+++ proj/setup.sh	(revision 219)
@@ -1,2 +1,3 @@
+helpers/xpm_to_xpm2.sh .
 cd font
-./setup.sh
\ No newline at end of file
+./setup.sh
Index: proj/setup_clean.sh
===================================================================
--- proj/setup_clean.sh	(revision 218)
+++ proj/setup_clean.sh	(revision 219)
@@ -1,2 +1,3 @@
+rm -rf xpm2/
 cd font
-./setup_clean.sh
\ No newline at end of file
+./setup_clean.sh