Index: proj/include/proj_func.h
===================================================================
--- proj/include/proj_func.h	(revision 239)
+++ proj/include/proj_func.h	(revision 240)
@@ -12,13 +12,6 @@
  */
 int cleanup(void);
 
-void update_key_presses(void);
-
-/**
- * @brief Updates movement variables.
- */
-void update_movement(const map_t *map, list_t *shooter_list);
-
 typedef struct keys {
     uint8_t w_pressed       : 1;
     uint8_t a_pressed       : 1;
@@ -30,6 +23,13 @@
     uint8_t lb_pressed      : 1;
 } keys_t;
 
+void update_key_presses(void);
+
+/**
+ * @brief Updates movement variables.
+ */
+void update_movement(const map_t *map, gunner_t *p, gunner_t *p2);
+
 void update_mouse(struct packet *p);
 
 keys_t* (get_key_presses)(void);
@@ -53,16 +53,4 @@
  */
 double get_mouse_angle(gunner_t *p);
 
-/**
- * @brief Get horizontal movement direction.
- * @return Horizontal movement direction (-1 -> heading LEFT; 0 -> not moving horizontally; 1 -> heading RIGHT)
- */
-int get_hor_movement(void);
-
-/**
- * @brief Get vertical movement direction.
- * @return Vertical movement direction (-1 -> heading UP; 0 -> not moving vertically; 1 -> heading DOWN)
- */
-int get_ver_movement(void);
-
 #endif /* end of include guard: PROJ_FUNC_H_INCLUDED */
Index: proj/src/proj.c
===================================================================
--- proj/src/proj.c	(revision 239)
+++ proj/src/proj.c	(revision 240)
@@ -54,14 +54,15 @@
     int r;
 
     #ifdef DIOGO
-        /*
         uint8_t conf;
-        if((r = util_sys_inb(0x3F8+3, &conf))) return 1; //printf("0x%02X\n", conf);
+        if((r = util_sys_inb(0x3F8+3, &conf))) return 1; printf("0x%02X\n", conf);
         conf = 0x19; //00011001
-        //printf("0x%02X\n", conf);
+        printf("0x%02X\n", conf);
         if((r = sys_outb(0x3F8+3, conf))) return 1;
-        if((r = util_sys_inb(0x3F8+3, &conf))) return 1; //printf("0x%02X\n", conf);
-        */
+        uint8_t s;
+        if((r = util_sys_inb(0x3F8+3, &s))) return 1; printf("S: 0x%02X\n", s);
+        return 0;
+
     #endif
 
     font_t *consolas = font_ctor("/home/lcom/labs/proj/media/font/Consolas/xpm2");
@@ -231,7 +232,7 @@
                             #ifdef TELMO
                             if (i == 0) {
                                 if (no_interrupts % refresh_count_value == 0) {
-                                    //update_movement(map1, shooter_list);
+                                    update_movement(map1, shooter1, shooter2);
                                     //bullet_update_movement(bullet);
 
                                     if (no_interrupts % 180 == 0) gunner_set_pos(shooter2, 775, 75);
Index: proj/src/proj_func.c
===================================================================
--- proj/src/proj_func.c	(revision 239)
+++ proj/src/proj_func.c	(revision 240)
@@ -25,7 +25,6 @@
     return r;
 }
 
-static int hor_mov = REST, ver_mov = REST;
 static keys_t key_presses;
 
 void update_key_presses(void) {
@@ -47,27 +46,25 @@
         case MINUS_BREAK_CODE   : key_presses.minus_pressed = 0;        break;
         }
     }
-    ver_mov = key_presses.s_pressed - key_presses.w_pressed;
-    hor_mov = key_presses.d_pressed - key_presses.a_pressed;
 }
-/*
-void update_movement(const map_t *map, list_t *shooter_list){
-    list_node_t *it1 = list_begin(shooter_list);
-    while(it1 != list_end(shooter_list)){
-        double x = gunner_get_x(p);
-        double y = gunner_get_y(p);
-        gunner_set_pos(p, x + SHOOTER_SPEED * hor_mov, y);
-        if (map_collides_gunner(map, p) || gunner_collides_gunner(p, p2)) {
-            gunner_set_pos(p, x, y);
-        }
+
+
+void update_movement(const map_t *map, gunner_t *p, gunner_t *p2) {
+    int ver_mov = key_presses.s_pressed - key_presses.w_pressed;
+    int hor_mov = key_presses.d_pressed - key_presses.a_pressed;
+    double x = gunner_get_x(p);
+    double y = gunner_get_y(p);
+    gunner_set_pos(p, x + SHOOTER_SPEED * hor_mov, y);
+    if (map_collides_gunner(map, p) || gunner_collides_gunner(p, p2)) {
+        gunner_set_pos(p, x, y);
+    }
         x = gunner_get_x(p);
-        gunner_set_pos(p, x, y + SHOOTER_SPEED * ver_mov);
-        if (map_collides_gunner(map, p) || gunner_collides_gunner(p, p2)) {
-            gunner_set_pos(p, x, y);
-        }
+    gunner_set_pos(p, x, y + SHOOTER_SPEED * ver_mov);
+    if (map_collides_gunner(map, p) || gunner_collides_gunner(p, p2)) {
+        gunner_set_pos(p, x, y);
     }
 }
-*/
+
 void (shoot_bullet)(const gunner_t *shooter, list_t *bullet_list, const basic_sprite_t *bsp_bullet) {
     double angle = gunner_get_angle(shooter);
     double vx = -BULLET_SPEED * fm_sin(angle);
@@ -162,7 +159,3 @@
 double get_mouse_angle(gunner_t *p) {
     return atan2(gunner_get_y_screen(p) - mouse_y, mouse_x - gunner_get_x_screen(p));
 }
-
-int get_hor_movement(void) { return hor_mov; }
-
-int get_ver_movement(void) { return ver_mov; }